/*
  CPP_CONTEST=2013Cal-2012
  CPP_PROBLEM=I
  CPP_LANG=C+OPENMP
  CPP_PROCESSES_PER_NODE=saturno 1
*/

/* RECORD
Juan Francisco Rodríguez Herrera 
students of the University of Almería, Spain
In the II Spanish Parallel Programming Contest, Elche, Spain
September 19, 2012
time 194 msec
speed-up 96.13
*/ 

/*RECORD in the new system
when the programs in the record table are run in the new system
formed by saturno (NUMA with four hexacores),
it is the absolute record, with
time 292 msec
speed-up 102.40
*/

#include <stdlib.h>
#include <omp.h>

extern void escribir(int *m, int t);
/*
void quicksort(int *d,int izq,int der,int n)
{
  int i,j,piv,t;

  if(izq>=der)
    return;
  else
  {
    i=izq+1;
    j=der;
    piv=d[izq];
    while(i<=j)
    {
      while(i<=der && d[i]<=piv)
        i++;
      while(d[j]>piv)
        j--;
      if(i<=der && j>i)
      {
        t=d[i];
        d[i]=d[j];
        d[j]=t;
      }
    }  
    if(j>izq)
    {
      d[izq]=d[j];
      d[j]=piv;
    }
    quicksort(d,izq,j-1,n);
    quicksort(d,j+1,der,n);
  }
}
*/

void quicksort(int *a, int lo, int hi) {
    int i=lo, j=hi, h;
    int x=a[(lo+hi)/2];

    do {
        while (a[i] < x) i++;
        while (a[j] > x) j--;
        if (i <= j) {
            h=a[i]; a[i]=a[j]; a[j]=h;
            i++; j--;
        }
    } while (i <= j);

    #pragma omp parallel sections
    {
        #pragma omp section
        if (lo < j) quicksort(a, lo, j);
        #pragma omp section
        if (i < hi) quicksort(a, i, hi);
    }
}


void transpose(int n,int *m,int *r)
{
  int i,j;

  for(i=0;i<n;i++)
  {
    for(j=0;j<n;j++)
    {
       r[i*n+j]=m[j*n+i];
    }
  }
}

void mmt(int t,int *a, int *r)
{
  int i, j, k, s,*at;

  at=(int *) malloc(sizeof(int)*t*t);

  transpose(t,a,at);
#ifdef DEBUG
// While debugging the transpose matrix is written
      escribir(at,t);
#endif
  #pragma omp parallel for private (j,k,s)
  for (i = 0; i < t; i++) 
  {
    for(j=0;j<t;j++)
    {
      s=0.;
      for (k = 0; k < t; k++)
	s = s+a[i*t+k]*at[j*t+k];
      r[i*t+j]=s;
    }
  }

  free(at);
}

void sec(int steps,int t,int *a)
{
  int i,*mtemp,*p;

  omp_set_num_threads(23);

  mtemp=(int *) malloc(sizeof(int)*t*t);

  for(i=0;i<steps;i++)
  {
    quicksort(a,0,t*t-1);
#ifdef DEBUG
// While debugging the matrix and the numbers are written
      escribir(a,t);
#endif
      mmt(t,a,mtemp);
      p=mtemp;
      mtemp=a;
      a=p;
#ifdef DEBUG
// While debugging the matrix and the numbers are written
      escribir(a,t);
#endif
  }
  if(steps%2==1)
  {
      p=mtemp;
      mtemp=a;
      a=p;
  }
  free(mtemp);
}
